
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all; 	

entity proc is
  port ( 
	clk  : in std_logic;
	rst  : in std_logic;
	pin  : in unsigned (11 downto 0); -- vhodna vrata
	pout1: out unsigned (11 downto 0) -- izhodna vrata
	 );
end proc;

architecture Opis of proc is

-- 12-bitni mikroprocesor
  component CPU is 
  port ( clk, ce: in std_logic; 
         rst: in std_logic;  
         data: in unsigned(11 downto 0);
         dat_i: in unsigned(11 downto 0);
         adr_o: out unsigned(7 downto 0);
         we_o: out std_logic;
         dat_o: out unsigned (11 downto 0);
         adr: out	unsigned(7 downto 0);
         dout: out unsigned(11 downto 0);
         we: out std_logic
	   );
  end component;

-- programski pomnilnik MegaWizard RAM: 1-PORT
  component program is 
   port ( 		
	 address : IN std_logic_vector (7 DOWNTO 0);
	 clken  : IN STD_LOGIC  := '1';
	 clock	: IN STD_LOGIC  := '1';
	 data  : IN std_logic_vector (11 DOWNTO 0);
	 wren  : IN STD_LOGIC ;
	 q    : OUT std_logic_vector (11 DOWNTO 0)
   );
  end component;

  -- clock enable za upocasnitev procesorja
  signal ce: std_logic;
  
  -- povezave med procesorjem in pomnilnikom
  signal data, dout: unsigned (11 downto 0) := x"000";
  signal adr: unsigned (7 downto 0);
  signal we: std_logic := '0';
  signal dataout, q: std_logic_vector (11 DOWNTO 0);
  signal address: std_logic_vector (7 DOWNTO 0);
  
  -- povezave na zunanje enote (vrata)
  signal dat_i:  unsigned (11 downto 0);
  signal adr_o:  unsigned (7 downto 0);
  signal dat_o:  unsigned (11 downto 0);
  signal we_o :  std_logic;
    
  signal pout0: unsigned(11 downto 0);
begin

 U1: CPU port map (clk=>clk, ce=>ce, rst=>rst, data=>data, dat_i=>dat_i, adr_o=>adr_o, we_o=>we_o, dat_o=>dat_o, adr=>adr, dout=>dout, we=>we);
 U2: program port map (clock=>clk, clken=>ce, address=>address, data=>dataout, wren=>we, q=>q);
  
 address <= std_logic_vector(adr);
 dataout <= std_logic_vector(dout);
 data <= unsigned(q);
  
 dat_i <= pin;
 
 -- dodaj delilnik ure in registre za izhodna vrata
end Opis;
